(* A lexical analyser for miniML *)

{
open Parser

let operators = [ "" ]
}

rule token = parse
    [' ' '\010' '\013' '\009' '\012'] +
      { token lexbuf }
  | '-'? ['0'-'9']+
      { INT(int_of_string(Lexing.lexeme lexbuf)) }
  | "," { COMMA }
  | "true" { TRUE }
  | "false" { FALSE }
  | "'" { APOSTROPHE }
  | ":" { SEMICOLON }
  | "*" { STAR }
  | "fun" { FUN }
  | "fst" { FST }
  | "snd" { SND }
  | "->" { ARROW }
  | "let" { LET }
  | "=" { EQUAL }
  | "in" { IN }
  | "(" { LPAREN }
  | ")" { RPAREN }
  | ['A'-'Z' 'a'-'z' '_'] ['A'-'Z' 'a'-'z' '0'-'9' '_'] *
      { let s = Lexing.lexeme lexbuf in
        if List.mem s operators then OP s else IDENT s }
  | eof { EOF }



